/*
 * Nombre del Proyecto:
     Proyecto_2.c
 * Nombre del Autor:
     Boris Puero
 * Description:
     El ejercicio consta de 2 partes, donde la primera es un Juego
     de operaciones matematicas y en la segunda parte consiste en la lectura
     de valores analogicos de un potenciometro en la patita RE0
 * Test configuration:
     MCU:             PIC16F887
     Oscillator:      HS, 08.0000 MHz
     SW:              mikroC PRO for PIC

 * NOTES:

*/// Keypad module connections
char  keypadPort at PORTD;
#include "mask.c"

// End Keypad module connections
// LCD module connections
sbit LCD_RS at RB4_bit;
sbit LCD_EN at RB5_bit;
sbit LCD_D4 at RB0_bit;
sbit LCD_D5 at RB1_bit;
sbit LCD_D6 at RB2_bit;
sbit LCD_D7 at RB3_bit;

sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D4_Direction at TRISB0_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D7_Direction at TRISB3_bit;
// End LCD module connections

//variables
unsigned char ch;
char *text,*text1,*text2,*text3;
char txt3[14] = "";
char txt4[14] = "";
char txt1[]="1.-J. de Operaciones";
char txt2[]="2.-Valores Analogico"   ;
char nombre[] = "  BORIS PUERO  ";
char txt5[] = "BORIS PUERO  ";
long arr[10], temp1[9];
long adc,tlong,maximo,uni,dec;
int i=0,cnt=0,cnt_2=0,ans=0,wins=0,band=0;
int j,name2, name1,dig_no;
unsigned short kp;

//Funciones
void juego();
void valor();
void salto();
void interrupt() ;
void poner(char *p);
int tecla(int a);
int answer(int res);

void salto(){
  Lcd_Cmd(_LCD_CLEAR);           // Comando LCD (borrar el LCD)
  kp=0;
  asm{
  GOTO 0X00
  }
}

void main() {
  OPTION_REG = 0x80;             // Set timer TMR0
  TMR0 = 0;
  INTCON = 0xA0;                 // Disable interrupt PEIE,INTE,RBIE,T0IE
  PORTC  = 0x00;
  TRISC  = 0x00;              // PORTC como salida
  PORTE=0;
  ADCON1 = 0x82;                 // Voltaje de referencia para la conversin A/D es VCC
  TRISE  = 0x01;              // RE0 is input, [RE1-RE7] are output
  Delay_ms(20);
  //Lcd_Cmd(_LCD_CLEAR);           // Comando LCD (borrar el LCD)
  band=0;
  ANSEL = 0x01;                  // Pin RE0 se configura como una entrada analgica
  ANSELH = 0;                    // Los dems pines se configuran como digitales
  PORTA  = 0x00;
  TRISA  = 0x00;              // PORTA como salida
  C1ON_bit = 0;               // Disable comparators
  C2ON_bit = 0;
  cnt = 0;                    // Resetear contador
  Lcd_Init();                 // Inicializa Lcd
  Lcd_Cmd(_LCD_CLEAR);        // Borrar display
  Lcd_Cmd(_LCD_CURSOR_OFF);   // Cursor apagado
  Delay_ms(1);
  Lcd_Out(1,1,txt1);           // Escribe texto en la primera linea
  Lcd_Out(2,1,txt2);           // Escribe texto en la segunda linea
  Lcd_Out(4,2,"Boris Puero -- P# 8");// Escribe texto en la cuarta linea
  Delay_ms(2000);
  Lcd_Cmd(_LCD_CLEAR);        // Borrar display
  Lcd_Out(1,4,"Boris Puero");           // Escribe texto en la primera linea
  Delay_ms(100);
    name1 = mask(14);  // llama a la P en mask
    name2 = mask(1); // llama a la b en mask

  do{
    for(i=0; i<10; i++) {      // Mover el texto a la derecha
       Lcd_Cmd(_LCD_SHIFT_RIGHT);
       Delay_ms(100);
       kp = Keypad_Key_Click(); // Almacena el codigo de la tecla en kp
       if(kp==1 || kp==2)
        i=10;
    }
    if(kp!=1 && kp!=2){
      for(i=0; i<10; i++) {      // Mover el texto a la izquierda
         Lcd_Cmd(_LCD_SHIFT_LEFT);
         Delay_ms(100);
         kp = Keypad_Key_Click();// Almacena el codigo de la tecla en kp
         if(kp==1 || kp==2)
          i=10;
      }
    }
  }while (kp!=1 && kp!=2);
  DELAY_MS(10);
  Lcd_Cmd(_LCD_CLEAR);               // Borrar display

  do {
    if(kp==1){
      Lcd_Cmd(_LCD_CLEAR);
      juego();}
    else{
      Lcd_Cmd(_LCD_CLEAR);
      valor();}
  } while (1);
}

void juego(){
  Lcd_Cmd(_LCD_CLEAR);
       Lcd_Out(1,3,"ON/C.-Habilitar");
     Lcd_Out(2,3,"Elegir_Operacion");
 Delay_ms(1000);
     do{
      kp = Keypad_Key_Click();    // Almacena el codigo de la tecla en kp
      cnt_2++;
      if(cnt_2>=20)
        cnt_2=1;
     }while (kp!=13);//mientras no se presione on/c
     do{
      kp = Keypad_Key_Click();   // Almacena el codigo de la tecla en kp
      cnt++;
      if(cnt>=20)
        cnt=1;
     }while (kp!=4 && kp!=8 && kp!=16);//mientras no se presione -, *, +

    do{
         band=1;
         delay_ms(50);
         Lcd_Cmd(_LCD_CLEAR);     // Borrar display
         delay_ms(50);
         WordToStr(cnt,txt1);     // Transform counter value to string
         WordToStr(cnt_2,txt2);    // Transform counter value to string
         Lcd_Out(1,1,txt1);
         Lcd_Out(1,8,txt2);
          switch (kp) {
            case  4:
                  Lcd_Out(1,6,"   -");
                  i= cnt-cnt_2;
                  i=abs(i);
                  break; // 2
            case  8:
                  Lcd_Out(1,6,"   x");
                  i= cnt*cnt_2;
                  break; // 3
            case  16:
                  Lcd_Out(1,6,"   +");
                  i= cnt+cnt_2;
                  break; // 3
          }
         ans = answer(i);
         if(ans==i)
          porta = ++wins;
          else
          wins=0;
       }while(wins!=0);
      Lcd_Cmd(_LCD_CLEAR);
      delay_ms(500);
      Lcd_Out(1,2,"Perdiste");
      Lcd_Out(2,2,"Numero Incorrecto");
      delay_ms(2000);
      salto();
      }
void valor(){
  Lcd_Cmd(_LCD_CLEAR);
  text2="Bin ADC:";
  text3="Dec ADC:";
     band=1 ;
       Lcd_Cmd(_LCD_CLEAR);           // Comando LCD (borrar el LCD)
         delay_ms(1000);
          do{
        kp = Keypad_Key_Click();
        adc= ADC_Read(5);        // Conversin A/D. Pin RE0 es una entrada.
        Lcd_Out(3,1,text2);           // Escribir el resultado en la tercera lnea
        Lcd_Out(4,1,text3);           // Escribir el resultado en la cuarta lnea
        delay_ms(100);
        //MOSTRAR EL VALOR DECIMAL DEL ADC

        WordToStr(adc,txt1);                   // Transform counter value to string
        Lcd_Out(4,13, txt1);                   // Display counter value on Lcd

        //MOSTRAR EL VALOR ANALOGICO EN BINARIO
        for(j=0;j<10;j++){
          temp1[j]=(int)adc%2;
          Lcd_Chr(3,20-j,48+temp1[j]);
          adc=adc/2;
          Delay_ms(1);
        }
      }while(kp!=15);
      salto();
   }
     // Lcd_Cmd(_LCD_CLEAR);

void interrupt(){
    if (dig_no==0) {
        PORTE = 0;                 // Turn off both displays
        PORTC = name1;            // Set mask for displaying ones on PORTD
        PORTE = 2;                 // Turn on display for ones (LSD)
        dig_no = 1;
    } else {
        PORTE = 0;                 // Turn off both displays
        PORTC = name2;           // Set mask for displaying tens on PORTD
        PORTE = 4;                 // Turn on display for tens (MSD)
        dig_no = 0;
    }
    TMR0 = 0;                      // Reset counter TMRO
    INTCON = 0x20;                 // Bit T0IF=0, T0IE=1
}

int tecla(int a){
    int x=0;
    switch (a) {
      case  1: x = 1; break; // 7        // Uncomment this block for keypad4x4
      case  2: x = 2; break; // 8
      case  3: x = 3; break; // 9
      case  5: x = 4; break; // 4
      case  6: x = 5; break; // 5
      case  7: x = 6; break; // 6
      case  9: x = 7; break; // 1
      case 10: x = 8; break; // 2
      case 11: x = 9; break; // 3
      case 14: x = 0; break; // 0
      default: return -1;
    }
    return x;
}
int answer(int res){
 int kpk=0,num1=0;
        do{
              kpk = Keypad_Key_Click(); // Almacena el codigo de la tecla en kp
              cnt_2++;
              if(cnt_2>=20) cnt_2=1;
              delay_ms(10);
        }while (!kpk);
        num1=tecla(kpk);
        cnt=cnt_2;
        if(kp==4)  cnt=cnt+13;
        if(res>9){
          do{
                kpk = Keypad_Key_Click();
                cnt_2++;
                if(cnt_2>=20) cnt_2=1;
                delay_ms(10);
          }while (!kpk);
          num1= num1*10 + tecla(kpk);
        }
        if(res>99){
          do
                kpk = Keypad_Key_Click();
          while (!kpk);
          num1= num1*10 + tecla(kpk);
        }
    return num1;
}